	.module Wasp_ISRs.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_ISRs.c
	.area vector(rom, abs)
	.org 80
	jmp _UART_RX_Interrupt
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_ISRs.c
	.area vector(rom, abs)
	.org 84
	jmp _UART_TX_Interrupt
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_ISRs.c
	.area vector(rom, abs)
	.org 64
	jmp _TIMER0_Compare_Interrupt
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_ISRs.c
	.area vector(rom, abs)
	.org 36
	jmp _TIMER2_Compare_Interrupt
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_ISRs.c
	.dbfunc e UART_RX_Interrupt _UART_RX_Interrupt fV
;        tmphead -> R18
;           data -> R16
	.even
_UART_RX_Interrupt::
	st -y,R2
	st -y,R3
	st -y,R4
	st -y,R5
	st -y,R16
	st -y,R18
	st -y,R19
	st -y,R24
	st -y,R25
	st -y,R30
	st -y,R31
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 87
; /**************************************************************
; 
;    Program Title:  Wasp AVR Monitor
;    
;    Program Name:  Wasp_ISRs.c		  Version: 0.85
;    
;    Author:  SS	  					  Date:  August 10, 2005
;    
;    Compiled with ImageCraft ICCAVR Standard V7.13A.
;    
;    This file contains routines that implement the interrupt service routines 
;    for the Wasp Monitor.
;    
;    Copyright 2004-2009, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright 2004-2009, SOC Robotics, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; /*
;  * $Log: Wasp_ISRs.c,v $
;  * Revision 0.86  2006/02/07 16:40:20  SS
;  *    2-wire interface, 8MHz clock, AVR Flash writer, XON/XOFF, 38,700baud
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom644v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; #include <stdio.h>
; #include "Wasp_Uart.h"
; #include "Wasp_Defines.h"
; #include "Wasp_Extern.h"
; 
; // Vector numbers for ATmega16
; //#pragma interrupt_handler UART_RX_Interrupt:12 UART_TX_Interrupt:13
; // Vector numbers for ATmega32
; //#pragma interrupt_handler UART_RX_Interrupt:14 UART_TX_Interrupt:16
; // Vector numbers for ATmega644
; #pragma interrupt_handler UART_RX_Interrupt:iv_USART0_RX
; #pragma interrupt_handler UART_TX_Interrupt:iv_USART0_UDRE
; #pragma interrupt_handler TIMER0_Compare_Interrupt:iv_TIMER0_COMPA
; #pragma interrupt_handler TIMER2_Compare_Interrupt:iv_TIMER2_COMPA
; 
; //*********************************************************
; //*********************************************************
; //     Interrupt handlers
; //*********************************************************
; //*********************************************************
; 
; //  USART serial receiver interrupt handler
; //  Flow control by XON/XOFF
; void UART_RX_Interrupt(void)
; {
	.dbline 90
; 	unsigned char data,tmphead;
; 	
; 	data = UCSR0A;
	lds R16,192
	.dbline 91
; 	if((data&0x10)) frameerror = YES;
	sbrs R16,4
	rjmp L2
X0:
	.dbline 91
	ldi R24,1
	sts _frameerror,R24
L2:
	.dbline 92
; 	if((data&0x08)) dataoverrun = YES;
	sbrs R16,3
	rjmp L4
X1:
	.dbline 92
	ldi R24,1
	sts _dataoverrun,R24
L4:
	.dbline 94
; 	
; 	data = UDR0;   // read the received data
	lds R16,198
	.dbline 96
; 	
; 	tmphead = (UART_RxHead+1)&UART_RX_BUFFER_MASK;  // calculate buffer index
	lds R18,_UART_RxHead
	subi R18,255    ; addi 1
	andi R18,63
	.dbline 97
; 	UART_RxHead = tmphead;      // store new index
	sts _UART_RxHead,R18
	.dbline 98
; 	UART_RxBuf[tmphead] = data; // store received data in buffer
	ldi R24,<_UART_RxBuf
	ldi R25,>_UART_RxBuf
	mov R30,R18
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	.dbline 100
; 	
; 	rxcnt++;
	lds R24,_rxcnt
	subi R24,255    ; addi 1
	sts _rxcnt,R24
	.dbline 101
; 	if(rxcnt>UART_RX_BUFFER_SIZE-1) rxcnt = UART_RX_BUFFER_SIZE-2;
	ldi R24,63
	lds R2,_rxcnt
	cp R24,R2
	brsh L6
X2:
	.dbline 101
	ldi R24,62
	sts _rxcnt,R24
L6:
	.dbline 103
; 	
; 	totalrxcnt++;
	lds R24,_totalrxcnt
	lds R25,_totalrxcnt+1
	adiw R24,1
	sts _totalrxcnt+1,R25
	sts _totalrxcnt,R24
	.dbline 104
; 	if(rxcnt>rxcntmax)  rxcntmax = rxcnt;
	lds R2,_rxcntmax
	clr R3
	lds R4,_rxcnt
	clr R5
	cp R2,R4
	cpc R3,R5
	brge L8
X3:
	.dbline 104
	mov R2,R4
	sts _rxcntmax,R2
L8:
	.dbline 108
; 
; 	// If receive buffer almost full Fire TX interrupt if 
; 	// transmit buffer empty otherwise alert Tx int routine XOFF must go
; 	if((rxcnt>(UART_RX_BUFFER_SIZE-30))&&(xoffsent==NO))  {
	ldi R24,34
	lds R2,_rxcnt
	cp R24,R2
	brsh L10
X4:
	lds R2,_xoffsent
	tst R2
	brne L10
X5:
	.dbline 108
	.dbline 109
; 	    if((UCSR0A&0x20))  UCSR0B |= (1<<UDRIE0);
	lds R2,192
	sbrs R2,5
	rjmp L12
X6:
	.dbline 109
	lds R24,193
	ori R24,32
	sts 193,R24
	xjmp L13
L12:
	.dbline 110
; 		else sendxoff = YES;
	ldi R24,1
	sts _sendxoff,R24
L13:
	.dbline 111
; 		}
L10:
	.dbline -2
L1:
	.dbline 0 ; func end
	ld R2,y+
	out 0x3f,R2
	ld R31,y+
	ld R30,y+
	ld R25,y+
	ld R24,y+
	ld R19,y+
	ld R18,y+
	ld R16,y+
	ld R5,y+
	ld R4,y+
	ld R3,y+
	ld R2,y+
	reti
	.dbsym r tmphead 18 c
	.dbsym r data 16 c
	.dbend
	.dbfunc e UART_TX_Interrupt _UART_TX_Interrupt fV
;        tmptail -> R16
	.even
_UART_TX_Interrupt::
	st -y,R2
	st -y,R3
	st -y,R16
	st -y,R17
	st -y,R24
	st -y,R25
	st -y,R30
	st -y,R31
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 125
; 	
; //	if((rxcnt>(UART_RX_BUFFER_SIZE-10))&&(xoffsent==NO)&&(enablexonoff==YES)) {
; //	if((rxcnt>(UART_RX_BUFFER_SIZE-10))&&(xoffsent==NO)) {
; 	// If tx buffer is empty then transmit xoff else signal tx to send xoff
; //	    sendxonxoff = YES;
; //		xoffsent = YES;
; //		UCSRB |= (1<<UDRIE);  // Fire TX interrupt	
; //		}
; }
; 
; //  UART transmit interrupt handler
; //  Flow control by XON/XOFF
; void UART_TX_Interrupt(void)
; {
	.dbline 129
; 	unsigned char tmptail;
; 
; 	// Check if all data has been transmitted
; 	if(UART_TxHead != UART_TxTail)  {
	lds R2,_UART_TxTail
	lds R3,_UART_TxHead
	cp R3,R2
	brne X17
	xjmp L15
X17:
X7:
	.dbline 129
	.dbline 131
; 	    // Check chars in rx buffer - if too many - transmit XOFF
; 		if((rxcnt>(UART_RX_BUFFER_SIZE-34))&&((xoffsent==NO)||(sendxoff==YES))){
	ldi R24,30
	lds R2,_rxcnt
	cp R24,R2
	brsh L17
X8:
	lds R2,_xoffsent
	tst R2
	breq L19
X9:
	lds R24,_sendxoff
	cpi R24,1
	brne L17
X10:
L19:
	.dbline 131
	.dbline 132
; 		    UDR0 = XOFF;
	ldi R24,19
	sts 198,R24
	.dbline 133
; 			xoffcnt++;
	lds R24,_xoffcnt
	lds R25,_xoffcnt+1
	adiw R24,1
	sts _xoffcnt+1,R25
	sts _xoffcnt,R24
	.dbline 134
; 			xoffsent = YES;
	ldi R24,1
	sts _xoffsent,R24
	.dbline 135
; 			sendxoff = NO;
	clr R2
	sts _sendxoff,R2
	.dbline 136
; 			}
	xjmp L16
L17:
	.dbline 137
; 		else if((rxcnt<5)&&(xoffsent==YES)) {
	lds R24,_rxcnt
	cpi R24,5
	brsh L20
X11:
	lds R24,_xoffsent
	cpi R24,1
	brne L20
X12:
	.dbline 137
	.dbline 138
; 		    UDR0 = XON;
	ldi R24,17
	sts 198,R24
	.dbline 139
; 			xoncnt++;
	lds R24,_xoncnt
	lds R25,_xoncnt+1
	adiw R24,1
	sts _xoncnt+1,R25
	sts _xoncnt,R24
	.dbline 140
; 			xoffsent = NO;
	clr R2
	sts _xoffsent,R2
	.dbline 141
; 		    }
	xjmp L16
L20:
	.dbline 142
; 		else {
	.dbline 144
; 			 // Calculate buffer index
; 			 tmptail = (UART_TxTail + 1) & UART_TX_BUFFER_MASK;
	lds R16,_UART_TxTail
	subi R16,255    ; addi 1
	andi R16,63
	.dbline 145
; 			 UART_TxTail = tmptail;     // Store new index
	sts _UART_TxTail,R16
	.dbline 146
; 			 UDR0 = UART_TxBuf[tmptail]; // Start transmission
	ldi R24,<_UART_TxBuf
	ldi R25,>_UART_TxBuf
	mov R30,R16
	clr R31
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	sts 198,R2
	.dbline 151
; //			 if(UART_TxBuf[tmptail]==XON) {
; //			 	  xoffsent = NO;
; //				  xonsent = NO;
; //				  }
; 			 }
	.dbline 152
; 		}
	xjmp L16
L15:
	.dbline 153
; 	else  {  // Check chars in rx buffer - if too many trans XOFF
	.dbline 154
; 		if((rxcnt>(UART_RX_BUFFER_SIZE-34))&&(xoffsent==NO)) {
	ldi R24,30
	lds R2,_rxcnt
	cp R24,R2
	brsh L22
X13:
	lds R2,_xoffsent
	tst R2
	brne L22
X14:
	.dbline 154
	.dbline 155
; 		    UDR0 = XOFF;
	ldi R24,19
	sts 198,R24
	.dbline 156
; 			xoffsent = YES;
	ldi R24,1
	sts _xoffsent,R24
	.dbline 157
; 			xoffcnt++;
	lds R24,_xoffcnt
	lds R25,_xoffcnt+1
	adiw R24,1
	sts _xoffcnt+1,R25
	sts _xoffcnt,R24
	.dbline 158
; 			}
	xjmp L23
L22:
	.dbline 159
; 		else if((rxcnt<5)&&(xoffsent==YES)) {
	lds R24,_rxcnt
	cpi R24,5
	brsh L24
X15:
	lds R24,_xoffsent
	cpi R24,1
	brne L24
X16:
	.dbline 159
	.dbline 160
; 		    UDR0 = XON;
	ldi R24,17
	sts 198,R24
	.dbline 161
; 			xoncnt++;
	lds R24,_xoncnt
	lds R25,_xoncnt+1
	adiw R24,1
	sts _xoncnt+1,R25
	sts _xoncnt,R24
	.dbline 162
; 			xoffsent = NO;
	clr R2
	sts _xoffsent,R2
	.dbline 163
; 		    }
	xjmp L25
L24:
	.dbline 164
; 		else UCSR0B &= ~(1<<UDRIE0); // Disable UDRE interrupt
	lds R24,193
	andi R24,223
	sts 193,R24
L25:
L23:
	.dbline 165
; 		}
L16:
	.dbline -2
L14:
	.dbline 0 ; func end
	ld R2,y+
	out 0x3f,R2
	ld R31,y+
	ld R30,y+
	ld R25,y+
	ld R24,y+
	ld R17,y+
	ld R16,y+
	ld R3,y+
	ld R2,y+
	reti
	.dbsym r tmptail 16 c
	.dbend
	.dbfunc e TIMER0_Compare_Interrupt _TIMER0_Compare_Interrupt fV
	.even
_TIMER0_Compare_Interrupt::
	st -y,R2
	st -y,R3
	st -y,R24
	st -y,R25
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 172
; }
; 
; //  Timer0 interrupts every msec - This routines decrements 
; //  countdown timers - other routines can control timing to 
; //  within 1 msec by monitoring these software timers
; void  TIMER0_Compare_Interrupt(void)
; {
	.dbline 173
;  	if(mseccountdown1>0)  mseccountdown1--;
	lds R2,_mseccountdown1
	lds R3,_mseccountdown1+1
	tst R2
	brne X18
	tst R3
	breq L27
X18:
	.dbline 173
	movw R24,R2
	sbiw R24,1
	sts _mseccountdown1+1,R25
	sts _mseccountdown1,R24
L27:
	.dbline 174
;  	if(mseccountdown2>0)  mseccountdown2--;
	lds R2,_mseccountdown2
	lds R3,_mseccountdown2+1
	tst R2
	brne X19
	tst R3
	breq L29
X19:
	.dbline 174
	movw R24,R2
	sbiw R24,1
	sts _mseccountdown2+1,R25
	sts _mseccountdown2,R24
L29:
	.dbline 175
; 	if(mseccountdown3>0)  mseccountdown3--;
	lds R2,_mseccountdown3
	lds R3,_mseccountdown3+1
	tst R2
	brne X20
	tst R3
	breq L31
X20:
	.dbline 175
	movw R24,R2
	sbiw R24,1
	sts _mseccountdown3+1,R25
	sts _mseccountdown3,R24
L31:
	.dbline 176
; 	if(flashcountdown>0)  flashcountdown--;
	lds R2,_flashcountdown
	lds R3,_flashcountdown+1
	tst R2
	brne X21
	tst R3
	breq L33
X21:
	.dbline 176
	movw R24,R2
	sbiw R24,1
	sts _flashcountdown+1,R25
	sts _flashcountdown,R24
L33:
	.dbline -2
L26:
	.dbline 0 ; func end
	ld R2,y+
	out 0x3f,R2
	ld R25,y+
	ld R24,y+
	ld R3,y+
	ld R2,y+
	reti
	.dbend
	.dbfunc e TIMER2_Compare_Interrupt _TIMER2_Compare_Interrupt fV
	.even
_TIMER2_Compare_Interrupt::
	st -y,R2
	st -y,R3
	st -y,R16
	st -y,R17
	st -y,R24
	st -y,R25
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 182
; }
; 
; //  Real Time Clock interrupts every 4msec - This routine decrements 
; //  countdown timers and maintains the watch clock
; void  TIMER2_Compare_Interrupt(void)
; {
	.dbline 183
;  	if(rtccountdown1>0)  rtccountdown1--;
	lds R2,_rtccountdown1
	lds R3,_rtccountdown1+1
	tst R2
	brne X22
	tst R3
	breq L36
X22:
	.dbline 183
	movw R24,R2
	sbiw R24,1
	sts _rtccountdown1+1,R25
	sts _rtccountdown1,R24
L36:
	.dbline 184
;  	if(rtccountdown2>0)  rtccountdown2--;
	lds R2,_rtccountdown2
	lds R3,_rtccountdown2+1
	tst R2
	brne X23
	tst R3
	breq L38
X23:
	.dbline 184
	movw R24,R2
	sbiw R24,1
	sts _rtccountdown2+1,R25
	sts _rtccountdown2,R24
L38:
	.dbline 185
; 	if(rtccountdown3>0)  rtccountdown3--;
	lds R2,_rtccountdown3
	lds R3,_rtccountdown3+1
	tst R2
	brne X24
	tst R3
	breq L40
X24:
	.dbline 185
	movw R24,R2
	sbiw R24,1
	sts _rtccountdown3+1,R25
	sts _rtccountdown3,R24
L40:
	.dbline 186
; 	if(rtccountdown4>0)  rtccountdown4--;
	lds R2,_rtccountdown4
	lds R3,_rtccountdown4+1
	tst R2
	brne X25
	tst R3
	breq L42
X25:
	.dbline 186
	movw R24,R2
	sbiw R24,1
	sts _rtccountdown4+1,R25
	sts _rtccountdown4,R24
L42:
	.dbline 189
; 	
; //	if(!(rtcclockcnt++)) {
; 	if(rtcclockcnt++==0) {
	lds R2,_rtcclockcnt
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	sts _rtcclockcnt,R24
	tst R2
	brne L44
X26:
	.dbline 189
	.dbline 191
; 	    //rtcclockcnt = 0;
; 	    if(seconds++>=59) {
	lds R2,_seconds
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	sts _seconds,R24
	mov R24,R2
	cpi R24,59
	brlo L46
X27:
	.dbline 191
	.dbline 192
; 		    seconds = 0;
	clr R2
	sts _seconds,R2
	.dbline 193
; 			if(minutes++>=59) {
	lds R16,_minutes
	clr R17
	mov R24,R16
	subi R24,255    ; addi 1
	sts _minutes,R24
	cpi R16,59
	brlo L48
X28:
	.dbline 193
	.dbline 194
; 			    minutes = 0;
	sts _minutes,R2
	.dbline 195
; 				if(hours++>=23) {
	lds R16,_hours
	clr R17
	mov R24,R16
	subi R24,255    ; addi 1
	sts _hours,R24
	cpi R16,23
	brlo L50
X29:
	.dbline 195
	.dbline 196
; 				    hours = 0;
	sts _hours,R2
	.dbline 197
; 					days++;
	lds R24,_days
	subi R24,255    ; addi 1
	sts _days,R24
	.dbline 198
; 					}
L50:
	.dbline 199
; 				}
L48:
	.dbline 200
; 			}
L46:
	.dbline 201
; 		}
L44:
	.dbline -2
L35:
	.dbline 0 ; func end
	ld R2,y+
	out 0x3f,R2
	ld R25,y+
	ld R24,y+
	ld R17,y+
	ld R16,y+
	ld R3,y+
	ld R2,y+
	reti
	.dbend
; }
