CC = iccavr
CFLAGS =  -IC:\ICC\include\ -e -D__ICC_VERSION="7.13A" -DATMEGA -D_EE_EXTIO -DATMega644  -l -g -Mavr_enhanced 
ASFLAGS = $(CFLAGS)  -Wa-g
LFLAGS =  -LC:\ICC\lib\ -g -e:0x10000 -ucrtatmega.o -bfunc_lit:0x70.0x10000 -dram_end:0x10ff -bdata:0x100.0x10ff -dhwstk_size:60 -beeprom:0.2048 -fihx_coff -S2
FILES = Wasp_Monitor.o Wasp_Init.o Wasp_ISRs.o Wasp_Utilities.o Wasp_SPI.o Wasp_SPI_Flash.o Wasp_Uart.o Wasp_TWI_Functions.o TWI_Master.o 

WASP_MONITOR:	$(FILES)
	$(CC) -o WASP_MONITOR $(LFLAGS) @WASP_MONITOR.lk   -lfpatmega -lcatmega
Wasp_Monitor.o: C:\iccv7avr\include\iom644v.h C:\iccv7avr\include\macros.h C:\iccv7avr\include\string.h C:\iccv7avr\include\_const.h C:\iccv7avr\include\stdlib.h C:\iccv7avr\include\limits.h C:\iccv7avr\include\math.h C:\iccv7avr\include\stdio.h C:\iccv7avr\include\stdarg.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Uart.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Defines.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Extern.h
Wasp_Monitor.o:	C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Monitor.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Monitor.c
Wasp_Init.o: C:\iccv7avr\include\iom644v.h C:\iccv7avr\include\macros.h C:\iccv7avr\include\string.h C:\iccv7avr\include\_const.h C:\iccv7avr\include\stdlib.h C:\iccv7avr\include\limits.h C:\iccv7avr\include\stdio.h C:\iccv7avr\include\stdarg.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Uart.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Defines.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Extern.h
Wasp_Init.o:	C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Init.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Init.c
Wasp_ISRs.o: C:\iccv7avr\include\iom644v.h C:\iccv7avr\include\macros.h C:\iccv7avr\include\string.h C:\iccv7avr\include\_const.h C:\iccv7avr\include\stdlib.h C:\iccv7avr\include\limits.h C:\iccv7avr\include\stdio.h C:\iccv7avr\include\stdarg.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Uart.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Defines.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Extern.h
Wasp_ISRs.o:	C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_ISRs.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_ISRs.c
Wasp_Utilities.o: C:\iccv7avr\include\iom644v.h C:\iccv7avr\include\macros.h C:\iccv7avr\include\string.h C:\iccv7avr\include\_const.h C:\iccv7avr\include\stdlib.h C:\iccv7avr\include\limits.h C:\iccv7avr\include\stdio.h C:\iccv7avr\include\stdarg.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Uart.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Defines.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Extern.h
Wasp_Utilities.o:	C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Utilities.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Utilities.c
Wasp_SPI.o: C:\iccv7avr\include\iom644v.h C:\iccv7avr\include\macros.h C:\iccv7avr\include\string.h C:\iccv7avr\include\_const.h C:\iccv7avr\include\stdlib.h C:\iccv7avr\include\limits.h C:\iccv7avr\include\stdio.h C:\iccv7avr\include\stdarg.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Uart.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Defines.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Extern.h
Wasp_SPI.o:	C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_SPI.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_SPI.c
Wasp_SPI_Flash.o: C:\iccv7avr\include\iom644v.h C:\iccv7avr\include\macros.h C:\iccv7avr\include\string.h C:\iccv7avr\include\_const.h C:\iccv7avr\include\stdlib.h C:\iccv7avr\include\limits.h C:\iccv7avr\include\stdio.h C:\iccv7avr\include\stdarg.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Uart.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Defines.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Extern.h
Wasp_SPI_Flash.o:	C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_SPI_Flash.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_SPI_Flash.c
Wasp_Uart.o: C:\iccv7avr\include\iom644v.h C:\iccv7avr\include\macros.h C:\iccv7avr\include\string.h C:\iccv7avr\include\_const.h C:\iccv7avr\include\stdlib.h C:\iccv7avr\include\limits.h C:\iccv7avr\include\stdio.h C:\iccv7avr\include\stdarg.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Uart.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Defines.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Extern.h
Wasp_Uart.o:	C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Uart.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Uart.c
Wasp_TWI_Functions.o: C:\iccv7avr\include\iom644v.h C:\iccv7avr\include\macros.h C:\iccv7avr\include\ctype.h C:\iccv7avr\include\string.h C:\iccv7avr\include\_const.h C:\iccv7avr\include\math.h C:\iccv7avr\include\stdlib.h C:\iccv7avr\include\limits.h C:\iccv7avr\include\eeprom.h C:\iccv7avr\include\stdio.h C:\iccv7avr\include\stdarg.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Uart.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Defines.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Extern.h
Wasp_TWI_Functions.o:	C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_TWI_Functions.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_TWI_Functions.c
TWI_Master.o: C:\iccv7avr\include\iom644v.h C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\TWI_Master.h
TWI_Master.o:	C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\TWI_Master.c
	$(CC) -c $(CFLAGS) C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\TWI_Master.c
